<?php

namespace ACL\Repositories;


use ACL\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class Organizacao extends RepositoryBase {

    Use TQuery;

    protected $table = 'ORGANIZACAO';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param $organizationId
     * @return array
     */
    public function findOrganizacao($organizationId): array
    {
        $query = "SELECT NRORG, NMORGANIZACAO
                    FROM ORGANIZACAO
                   WHERE NRORG = :NRORG";

        $params = array(
            "NRORG" => $organizationId
        );

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }

    /**
     * @param $filter
     * @return mixed[]
     */
    public function findOrganizacaoRelacionadaByOperador($filter): array
    {
        $query = <<<SQL
            SELECT NRORG, NMORGANIZACAO AS NMORGANIZACAOOPER, NMRAZSOCIALORG
              FROM ORGANIZACAO
             WHERE 1 = 1
             $filter        
SQL;
        dd($query);
        return $this->entityManager->getConnection()->fetchAllAssociative($query);
    }
}
