import { Tabs } from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { ITabsDetail, ITabsDetailEvents } from '@/components/common/tabs-detail/Interfaces';

export class TabsDetail extends Tabs implements ITabsDetail {
	/* Tabs name */
	public name!: string;

	/* Tabs title */
	public title: string = '';

	/* Tabs currentLabel */
	public currentLabel: string;

	/* Form events */
	public events!: ITabsDetailEvents;

	public headerLeftSlot = [
		{
			name: 'xxx',
			component: 'ZdButton',
			icon: true,
			small: true,
			iconName: 'mdi-arrow-left',
			events: {
				click: this.clickBackFromTabs.bind(this),
			},
		},
		{
			name: '',
			component: 'ZdText',
			tag: 'h3',
			text: this.currentLabel,
		},
	];

	public HeaderRightSlot = [];

	/**
	 * Form Save constructor
	 * @param props Form Save properties
	 */
	constructor(props: ITabsDetail) {
		super(props);
		this.title = this.getInitValue('title', props.title, this.title);
		this.name = this.getInitValue('name', props.name, this.name);
		this.currentLabel = this.getInitValue('currentLabel', props.currentLabel, '');

		this.setHeaderLeftSlot();

		this.createAccessors();
	}

	private setHeaderLeftSlot() {
		this.headerLeftSlot[0].name = `${this.name}_back_button`;
		this.headerLeftSlot[1].name = `${this.name}_currentLabel`;
		this.headerLeftSlot[1].text = this.currentLabel;
	}

	private clickBackFromTabs({ event, element }: IEventParam<TabsDetail>) {
		console.log(event, element);
		if (this.events.clickBackFromTabs) {
			this.events.clickBackFromTabs({});
		}
	}
}
